function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import * as React from 'react';
import { View, StyleSheet } from 'react-native';
import get from 'lodash.get';
import WrappedComponent from './WrappedComponent';
import { spaceUtils } from '../utils/space';
import { boxAlignUtils } from '../utils/box/align';
import { borderUtils } from '../utils/border';
import { boxSizeUtils } from '../utils/box/size';
import { boxFlexUtils } from '../utils/box/flex';
import { boxRowsUtils } from '../utils/box/rows';
import { radiusUtils } from '../utils/box/radius';
import { shadowUtils } from '../utils/box/shadow';
import { opacityUtils } from '../utils/opacity';
import { flattenStyle } from '../utils/flattenStyle';
import { positionUtils } from '../utils/position';

const Box = ({
  theme,
  m,
  margin,
  mb,
  marginBottom,
  mt,
  marginTop,
  mr,
  marginRight,
  ml,
  marginLeft,
  my,
  marginVertical,
  mx,
  marginHorizontal,
  p,
  padding,
  pb,
  paddingBottom,
  py,
  paddingVertical,
  pt,
  paddingTop,
  pr,
  paddingRight,
  pl,
  paddingLeft,
  px,
  paddingHorizontale,
  radius,
  borderRadius,
  avatar,
  circle,
  center,
  border,
  shadow,
  boxShadow,
  f,
  flex,
  h,
  height,
  w,
  width,
  align,
  alignItems,
  justify,
  justifyContent,
  self,
  alignSelf,
  dir,
  flexDirection,
  flexWrap,
  o,
  opacity,
  bg,
  backgroundColor,
  rows,
  children,
  position,
  top,
  bottom,
  left,
  right,
  style: customStyle,
  ...rest
}) => {
  const _space = spaceUtils({
    m,
    mb,
    mt,
    mr,
    ml,
    my,
    mx,
    p,
    pb,
    py,
    pt,
    pr,
    pl,
    px,
    theme
  });

  const _align = boxAlignUtils({
    center
  });

  const _border = borderUtils({
    border,
    theme
  });

  const _shadow = shadowUtils({
    shadow: shadow !== null && shadow !== void 0 ? shadow : boxShadow,
    theme
  });

  const _size = boxSizeUtils({
    w: w !== null && w !== void 0 ? w : width,
    h: h !== null && h !== void 0 ? h : height
  });

  const _flex = boxFlexUtils({
    align: align !== null && align !== void 0 ? align : alignItems,
    justify: justify !== null && justify !== void 0 ? justify : justifyContent,
    dir: dir !== null && dir !== void 0 ? dir : flexDirection,
    f: f !== null && f !== void 0 ? f : flex,
    self: self !== null && self !== void 0 ? self : alignSelf,
    flexWrap
  });

  const _radius = radiusUtils({
    theme,
    radius: radius !== null && radius !== void 0 ? radius : borderRadius,
    circle,
    avatar,
    children,
    size: {
      height: h !== null && h !== void 0 ? h : height,
      width: w !== null && w !== void 0 ? w : width
    }
  });

  const _opacity = opacityUtils({
    o: o !== null && o !== void 0 ? o : opacity,
    theme
  });

  const _position = positionUtils({
    position,
    top,
    bottom,
    right,
    left
  });

  const _style = {};
  const themeColor = get(theme, 'color');

  const _bg = bg !== null && bg !== void 0 ? bg : backgroundColor;

  if (_bg) {
    const color = themeColor[_bg];

    if (color) {
      _style.backgroundColor = color;
    } else {
      _style.backgroundColor = _bg;
    }
  }

  let newChild;

  if (avatar) {
    newChild = _radius.children;
  } else {
    newChild = boxRowsUtils({
      rows,
      children
    });
  }

  const _customStyle = flattenStyle(customStyle);

  const style = StyleSheet.create({
    box: { ..._style,
      ..._space,
      ..._align,
      ..._border,
      ..._shadow,
      ..._size,
      ..._flex,
      ..._radius.style,
      ..._opacity,
      ..._position,
      ..._customStyle
    }
  });
  return /*#__PURE__*/React.createElement(View, _extends({}, rest, {
    style: style.box
  }), newChild);
};

Box.defaultProps = {
  style: {}
};
Box.displayName = 'Box';
export default WrappedComponent(Box);
//# sourceMappingURL=Box.js.map